
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android APK瘦身实践 / iVAN</title>

    <meta name="description" content="Android APK瘦身实践 因为推广的需要,公司需要把APK的大小再&quot;减小&quot;一下,4M以内! 当达到4M以内之后,公司建议说,能否再压压?2M如何? 瘦身前 因为平时就考虑到大小的限制,所以很多工作已经做过了,如下列举现在的状态: 7.3M(Debug版本)和6.5M(Release版本) 开启minifyEnabled 开启shrinkResources 已经去除不相关的大型库 图片和代码已经经历过粗略的一轮清理 开始魔鬼瘦身 1. tinypng有损压缩 android打包本身会对png进行无损压缩 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Android APK瘦身实践</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>因为推广的需要，公司需要把APK的大小再“减小”一下，4M以内!</p>
<p>当达到4M以内之后，公司建议说，能否再压压?2M如何?</p>
<p><strong>瘦身前</strong></p>
<p>因为平时就考虑到大小的限制，所以很多工作已经做过了，如下列举现在的状态：</p>
<ol>
<li>7.3M(Debug版本)和6.5M(Release版本)</li>
<li>开启minifyEnabled</li>
<li>开启shrinkResources</li>
<li>已经去除不相关的大型库</li>
<li>图片和代码已经经历过粗略的一轮清理</li>
</ol>
<p><strong>开始魔鬼瘦身</strong></p>
<p><strong>1. tinypng有损压缩</strong></p>
<p>android打包本身会对png进行无损压缩，不信大家可以看看apk中的图片的大小实际上比你代码工程里的图片要小(针对没进行过无损压缩的那些png图)。</p>
<p>所以，纯粹的进行无损压缩并不会对apk的减小有任何效果，这是我特别想在这里强调的一个经验。</p>
<p>现在大家主流的比较喜欢用的tinypng其实是有损压缩：</p>
<p>https://tinypng.com/</p>
<p>[原文] TinyPNG uses smart lossy compression techniques to reduce the file size of your PNG files…</p>
<p>[翻译] TinyPNG使用智能有损压缩技术，来减少PNG文件的大小…</p>
<p>通过tinypng确实能在尽量少的损失下再减小apk，如果图片资源多或者大的话，效果还是很明显的。</p>
<p>具体减少多少，因为这个处理过程我们是间隔做的，无法准确给出结果，就按200k～500k算吧。</p>
<p><strong>2. png换成jpg</strong></p>
<p>经验发现，一些背景，启动页，宣传页的PNG图片比较大，这些图片图形比较复杂，如果转用有损JPG可能只有不到一半(当然是有损，不过通过设置压缩参数可以这种损失比较小到忽略)。</p>
<p>因为都是大图，所以这种方式能有效减小apk的大小。</p>
<p>这种情况下的apk的减小是不可估量的。</p>
<p><strong>3. jpg换成webp</strong></p>
<p>如果png大图转成jpg还是很大，或者想压的更小，而尽量不降低画质，那么可以考虑一下webp。</p>
<p>android 4.0+才原生支持webp, 但是我们的app是兼容2.3+，所以4.0以下的设备将无法看到图片。</p>
<p>考虑到我们4.0以下的所有设备比例之和大约在0.44%，非常少</p>
<p>4.0以下的设备不会崩溃</p>
<p>我们选择不对4.0以下做webp兼容处理，不显示就不显示。否则，要引入webp相关so文件增大apk大小。</p>
<p>通过把下面四张大图换成webp，webp的quality参数按50配置(据说官方评测75是最佳值)，清晰度勉强可以接受，这个值大家具体按产品要求来定。</p>
<p><a href="http://s3.51cto.com/wyfs02/M02/8E/29/wKioL1i3uKCT_Ze0AAD1GQZbgmg571.png-wh_651x-s_1582083205.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvOEUvMjkvd0tpb0wxaTN1S0NUX1plMEFBRDFHUVpiZ21nNTcxLnBuZy13aF82NTF4LXNfMTU4MjA4MzIwNS5wbmc=.jpg"></a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczQuNTFjdG8uY29tL3d5ZnMwMi9NMDEvOEUvMkIvd0tpb20xaTN1dDdRX00ySEFBQUFBQUFBQUFBODk5LmpwZw==.jpg"></p>
<p>其中安装jpg转webp工具:</p>
<pre>
</pre>
<ol>
<li>brew install webp </li>
</ol>
<p>转换命令如下</p>
<pre>
</pre>
<ol>
<li>cwebp -q input.jpg output.webp// Example:cwebp -q 50 a.jpg a.webp </li>
</ol>
<p>更多下载：https://developers.google.com/speed/webp/docs/precompiled</p>
<p>最终，apk减小了188k。</p>
<p><strong>4. 大图缩小</strong></p>
<p>如果经过上面的步骤，依然存在大图的话，说明确实图有点大了，可能真的有点大了!</p>
<p>所以，要考虑的问题是，是否有必要保证如此的大小?能否缩小?</p>
<p>如果这方面能减小的话，apk瘦身的效果必然又会上一个档次。</p>
<p>这种情况下的apk的减小是不可估量的。</p>
<p><strong>5. 覆盖aar里的一些默认的大图</strong></p>
<p>一些aar库里面包含根本就没有用的图。最典型的是support-v4兼容库中包含一些“可能”用到的图片，实际上在你的app中不会用到。</p>
<p><a href="http://s5.51cto.com/wyfs02/M00/8E/2B/wKiom1i3uNWQ4p9_AAJW82nd6_Q830.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczUuNTFjdG8uY29tL3d5ZnMwMi9NMDAvOEUvMkIvd0tpb20xaTN1TldRNHA5X0FBSlc4Mm5kNl9RODMwLnBuZw==.jpg"></a></p>
<p>我没有把所有图都替换掉，只是把几张大一点点的图(选中的那些图)用1×1的图片替换，如果9patch图的话，要做成3×3的9patch图替换。</p>
<p>support库可能还算好的，就怕有些库引用了一些大图而不自知，可以在/build/intermediates/exploded-aar/下的各个aar库的res目录查找检验。</p>
<p>apk减小了18k。</p>
<p><strong>6. 删除armable-v7包的so</strong></p>
<p>感谢@杨辉__ ,@kymjs张涛的提醒，armable-v7和armable文件夹可以只保留armable。</p>
<p>当然，armable-v7a的库会对图形渲染方面有很大的改进，因为我们主要是一些业务上动态库，所以删掉无大碍。</p>
<p><a href="http://s5.51cto.com/wyfs02/M00/8E/29/wKioL1i3uOLQBagYAAAcX4VK9k0160.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczUuNTFjdG8uY29tL3d5ZnMwMi9NMDAvOEUvMjkvd0tpb0wxaTN1T0xRQmFnWUFBQWNYNFZLOWswMTYwLnBuZw==.jpg"></a></p>
<p>apk减小了191k。</p>
<p><strong>7. 微信资源压缩打包</strong></p>
<p>这个方案网上一直在说，之前一直没有需求或者动力实践，在这里感谢一下@裸奔的凯子哥的推荐和交流，他那边的apk可以压小1M，效果还是比较惊人的。</p>
<p>这个步骤我是在后面很多步压缩之后测试的，每个阶段的压缩结果都会有些许出入，所以数据仅供参考。</p>
<ul>
<li>通过正常压缩，apk包减小了464k。</li>
<li>如果开启7zip，apk包减小了594k。</li>
<li>apk减小了594k。</li>
</ul>
<p>PS: 关于这个压缩，我集成到了gradle脚本中了，新建了一个Task，大概代码如下：</p>
<pre>
</pre>
<ol>
<li>task compressReleaseApp { </li>
<li> </li>
<li>    // 在现有release的版本上生成到compressed目录下 </li>
<li> </li>
<li>    def appid = "appid" </li>
<li> </li>
<li>    def channel = "abcdefghijkl" </li>
<li> </li>
<li>    def guardJarFile = file('../AndResGuard/andresguard-1.1.jar') </li>
<li> </li>
<li>    def guardConfigFile = file('../AndResGuard/config.xml') </li>
<li> </li>
<li>    def originApkFile = file("../app.${appid}/build/outputs/apk/release/${appid}-release-${rootProject.ext.versionName}-${rootProject.ext.versionCode}-${channel}.apk") </li>
<li> </li>
<li>    def outputDir = file("../app.${appid}/build/outputs/apk/compressed/") </li>
<li> </li>
<li>    def keystoreFile = file(RELEASE_STORE_FILE) </li>
<li> </li>
<li>    // 开始执行压缩命令 </li>
<li> </li>
<li>    def proc = "java -jar ${guardJarFile} ${originApkFile} -config ${guardConfigFile} -out ${outputDir} -signature ${keystoreFile} ${RELEASE_STORE_PASSWORD} ${RELEASE_KEY_PASSWORD} ${RELEASE_KEY_ALIAS}".execute(); </li>
<li> </li>
<li>    proc.waitFor(); </li>
<li> </li>
<li>    println "return code: ${ proc.exitValue()}" + ", stderr: ${proc.err.text}" + " stdout: ${proc.in.text}" </li>
<li> </li>
<li>} </li>
</ol>
<p>config开启了7zip, 部分配置如下：</p>
<pre>
</pre>
<ol>
<li>&lt;?xml version="1.0" encoding="UTF-8"?&gt; </li>
<li> </li>
<li>&lt;resproguard&gt; </li>
<li> </li>
<li>    &lt;!--defaut property to set  --&gt; </li>
<li> </li>
<li>    &lt;issue id="property" &gt; </li>
<li> </li>
<li>        &lt;seventzip value= "true" /&gt; </li>
<li> </li>
<li>        &lt;!--  ...  --&gt; </li>
<li> </li>
<li>    &lt;/issue&gt; </li>
<li> </li>
<li>  </li>
<li> </li>
<li>    &lt;issue id="whitelist" isactive="true"&gt; </li>
<li> </li>
<li>        &lt;path value ="com.xxx.yyy.R.drawable.emoji_*" /&gt; </li>
<li> </li>
<li>        &lt;path value ="com.xxx.yyy.... /&gt; </li>
<li> </li>
<li>    &lt;/issue&gt; </li>
<li> </li>
<li>  </li>
<li> </li>
<li>    &lt;issue id ="compress" isactive="true"&gt; </li>
<li> </li>
<li>        &lt;!--  ...  --&gt; </li>
<li> </li>
<li>    &lt;/issue&gt; </li>
<li> </li>
<li>&lt;/resproguard&gt;  </li>
</ol>
<p>详情参考：https://github.com/shwenzhang/AndResGuard</p>
<p>原理介绍：</p>
<p>http://mp.weixin.qq.com/s?__biz=MzAwNDY1ODY2OQ==&amp;mid=208135658&amp;idx=1&amp;sn=ac9bd6b4927e9e82f9fa14e396183a8f#rd</p>
<p><strong>8. proguard深度混淆代码</strong></p>
<p>之前为了简单起见，很多包都直接忽略了，现在启动严格模式，把能混淆的都混淆了：</p>
<p><a href="http://s4.51cto.com/wyfs02/M01/8E/29/wKioL1i3uPHRRhgoAAAiRPqcXbk825.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczQuNTFjdG8uY29tL3d5ZnMwMi9NMDEvOEUvMjkvd0tpb0wxaTN1UEhSUmhnb0FBQWlSUHFjWGJrODI1LnBuZw==.jpg"></a> <br />
<br />采用微信压缩方案最终效果比较：</p>
<p><a href="http://s4.51cto.com/wyfs02/M02/8E/29/wKioL1i3uW2TGq45AAAZPt5GxaM868.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczQuNTFjdG8uY29tL3d5ZnMwMi9NMDIvOEUvMjkvd0tpb0wxaTN1VzJUR3E0NUFBQVpQdDVHeGFNODY4LnBuZw==.jpg"></a></p>
<p>apk减小了215k。</p>
<p>PS:混淆后，一定要经过严格测试，有时候甚至很难发现错误，比如我开启严格混淆，用了一段时间之后慢慢发现了两个bug，排除了两个包程序才正常。</p>
<p><strong>9. 深度清理代码和资源</strong></p>
<p>有意思的是，无论何时何地去清理代码和资源，总能有新的发现:</p>
<ul>
<li>新发现或者新引入的无用图片</li>
<li>这几张图怎么一样</li>
<li>这个类好像没有用</li>
<li>没用的类相关的图片也没用</li>
<li>有些图片可以用着色方案替换</li>
<li>有些图片可以用shape来代替</li>
<li>hdpi里的ic_luancher.png好像也可以删掉</li>
<li>…</li>
</ul>
<p>apk减小了66k。</p>
<p><strong>10. proguard去符号表</strong></p>
<p>之前为了保留调试信息，我们是在Proguard保留了符号表的：</p>
<p>-keepattributes SourceFile,LineNumberTable</p>
<p>官方渠道我觉得还是尽量保留这个，现在针对推广渠道，只能采用特殊手段，注释这一行。</p>
<p>apk减小了230k。</p>
<p>ps:以后友盟上看推广渠道的bug要辛苦一点，手动上传mapping.txt了。</p>
<p><strong>11. provided关键字</strong></p>
<p>可以对仅在运行时需要的库设置provided关键字，实际并不被打包：</p>
<pre>
</pre>
<ol>
<li>provided 'com.android.support:support-annotations:22.0.0' </li>
</ol>
<p>我没有发现这样的场景，如果说有的话，就是support-annotations，但是经过后来的测试验证，support-annotations本来就会在release版本中被minifyEnabled掉，所以对support-annotations设置provided是没有意义的。</p>
<p>如果有实际场景，欢迎留言说明，不甚感激。</p>
<p>apk没有减小。</p>
<p><strong>12. 表情包在线化</strong></p>
<p>虽然应用的表情不多，只有50来个，但是如果能把这部分表情放到网上，不仅能有效减小apk大小，还可以方便后期扩展支持：</p>
<p><a href="http://s3.51cto.com/wyfs02/M00/8E/2B/wKiom1i3uafCpYsoAAB1qBTXKdw329.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvOEUvMkIvd0tpb20xaTN1YWZDcFlzb0FBQjFxQlRYS2R3MzI5LnBuZw==.jpg"></a></p>
<p>打包成emoji_v1.zip, 大小是202k。</p>
<p>现在把emoji_v1.zip放到网上，按需下载后使用，最终对比结果如下：</p>
<p><a href="http://s3.51cto.com/wyfs02/M01/8E/2B/wKiom1i3ubPxxv1kAAAiITs0gFY353.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvOEUvMkIvd0tpb20xaTN1YlB4eHYxa0FBQWlJVHMwZ0ZZMzUzLnBuZw==.jpg"></a></p>
<p>apk减小了193k。</p>
<p><strong>13. 全版本兼容的着色方案</strong></p>
<p>考虑着色方案主要目的是更方便支持多主题，减轻UI工作量，减少工程里一大堆selector文件等，然后才是，顺便的减小一下apk大小。</p>
<p>通过着色方案，我们去除了10多张纯色的按下状态图片和对应的xml等等。</p>
<p>apk减小了15k。</p>
<p>PS: 具体实现可以参考 http://www.race604.com/tint-drawable/ ，而我也把它集成到了我的LessCode库中了：DrawableLess.java：https://github.com/openproject/LessCode/blob/master/lesscode-core/src/main/java/com/jayfeng/lesscode/core/DrawableLess.java</p>
<p><strong>14. 去除重复库</strong></p>
<p>发现两个地方：</p>
<ul>
<li>现在发现七牛的SDK引用了android-async-http-1.4.6.jar，虽然不大，只有95.4k，但是感觉完全可以写一个轻量级的jar，控制在10～20k就足够了，具体可以在现有的网络库上实现。</li>
<li>自己工程使用的是UIL，但是引入的第三方库引用了picasso，两个重复的图片下载库也是完全没用必要的。</li>
</ul>
<p>现在还没有处理这块，新任务介入，延期优化，敬请期待。</p>
<p><strong>15. 去除无用库</strong></p>
<p>这是一个很基本的点，但是确很容易被人忽视，当你仔细回顾的时候，有一些鸡肋的功能或者库，是几无用处的。不如干脆去掉。</p>
<p>比如，在很早的时候，我就把我们app里的sharesdk删除了，因为对于我们的产品定位和推广来看，这毫无意义。</p>
<p>这种情况下的apk的减小是不可估量的。</p>
<p><strong>16. 去除百度统计</strong></p>
<p>这个视具体情况决定。</p>
<p>因为我们的APP里面包含友盟和百度两套统计系统，早期老板要求，事实上后面已经很少看这方面的数据，百度统计的数据几乎没用人去看，可以暂时先去除。</p>
<p>原本的百度统计的jar有130多k，去除之后的apk的减小会远远没有这么多。</p>
<p>apk减小了20k。</p>
<p><strong>17. 使用更小的库</strong></p>
<p>使用更小的库不应该成为你选择方案的决定性因素，但是可以作为参考因素(freso确实太大了，这个大小也可以成为决定性因素)。</p>
<p>图片下载，网络请求，json解析等等的库和它的竞品都有多大，你心里有数吗?</p>
<p>以工具库为例，网上有很多工具库，但是往往它们的大小很难控制。</p>
<ul>
<li>xutils-3.2.6.aar – 843.8k</li>
<li>lite-common-1.1.3.jar – 148.1k</li>
<li>lesscode-core-0.8.2.aar – 64k</li>
<li>…</li>
</ul>
<p>上面最后一个库LessCode是我自己收集的工具类集合，非常小：LessCode，混淆后只有不到50k大小。</p>
<p>不仅提高了开发效率，减少了冗余代码，而且能避免引用一些其他大型的库，有效避免包的增大。</p>
<p>比如，我们碰到过这样的一个bug，快速点击按钮多次触发跳转，现在RxJava结合RxBind有这样的一个场景解决方案，如果引入这些库的话必然会增大apk大小，实际上就几行代码，我把这样的解决方案集成到了LessCode，下次别的项目碰到这样的问题不用再犹豫是否要引入一个这么大的库了。</p>
<p>这些小的工具库，建议根据自己的经验人手总结一个，不求全，但求精!</p>
<p>这种情况下的apk的减小是不可估量的。</p>
<p><strong>18. 插件化</strong></p>
<p>尴尬的是，我们所呈现的功能大部分都是重要的不可分割的功能，很难从业务上分离出来。</p>
<p>今年预计要实践一个轻量级的插件化方案，用别人的也好，自己写也好，希望能解决或者优化一些安装包加载多模块，或者主题切换，或者热修复的问题。</p>
<p>这里作为候选方案备用。</p>
<p>这种情况下的apk的减小是不可估量的。</p>
<p><strong>19. 功能业务取舍</strong></p>
<p>一开始考虑瘦身，领导是允许适当的砍掉一些功能，因为4M的目标我们已经实现了，所以现在还没有到砍功能的地步。</p>
<p>这里作为候选方案备用。</p>
<p>这种情况下的apk的减小是不可估量的。</p>
<p><strong>补充</strong></p>
<p>文章发出后，收到了一些朋友的建议，补充几点。</p>
<p><strong>1. 去除无用的语言资源</strong></p>
<p>感谢@牧志轩的建议，通过配置resConfigs可以选择只打包哪几种语言，进而去掉各种aar包中全世界的语言，尤其是support包中的。</p>
<p><a href="http://s2.51cto.com/wyfs02/M01/8E/2B/wKiom1i3ufnCsuTgAAA48KJlR-E822.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczIuNTFjdG8uY29tL3d5ZnMwMi9NMDEvOEUvMkIvd0tpb20xaTN1Zm5Dc3VUZ0FBQTQ4S0psUi1FODIyLnBuZw==.jpg"></a></p>
<p>选择保留什么语言要根据产品的用户和市场来定，如果只选择默认英语和中文语言，配置如下</p>
<pre>
</pre>
<ol>
<li>android { </li>
<li> </li>
<li>    defaultConfig { </li>
<li> </li>
<li>        resConfigs "zh" </li>
<li> </li>
<li>    } </li>
<li> </li>
<li>}  </li>
</ol>
<p>看看效果：</p>
<p><a href="http://s2.51cto.com/wyfs02/M02/8E/29/wKioL1i3uhDwB8yzAABwvrtv_yY713.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczIuNTFjdG8uY29tL3d5ZnMwMi9NMDIvOEUvMjkvd0tpb0wxaTN1aER3Qjh5ekFBQnd2cnR2X3lZNzEzLmpwZw==.jpg"></a></p>
<p>如果不采用微信压缩方案结果对比，apk减小了197k。</p>
<p>如果采用微信压缩(开启7zip)对比结果，apk只减小了16k，因为微信对resources.arsc进行了强力压缩，厉害!</p>
<p>apk减小了16k。</p>
<p><strong>2. 删除x86包的so</strong></p>
<p>再次感谢@杨辉__的建议，x86的包删除了之后，测试反应好像有些机器容易崩溃，未能经过严格测试，所以主版本又复原了，只在个别渠道执行这条措施。</p>
<p>一般情况下不会有问题，测试了一下效果，apk减小了78k。</p>
<p>这里作为候选方案备用。</p>
<p><strong>小结</strong></p>
<p>最终，我们成功的把apk压到了2.9M，如果把上面遗漏的步骤继续再做，应该还能再减小一点。</p>
<p>客户反应压的好小，领导简直不敢相信～</p>
<p>瘦身不难，难的是魔鬼瘦身!</p>
<p>本文作者：佚名</p>
<p>来源：51CTO</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 13:26:11</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%b5%8b%e8%af%95/" title="测试">测试</a>, <a href="https://www.iamivan.net/tag/android/" title="android">android</a>, <a href="https://www.iamivan.net/tag/file/" title="file">file</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Android APK瘦身实践的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR1daab.html" rel="bookmark">Android APP瘦身（清除工程中没用到的资源）详解&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				清除Android工程中没用到的资源 项目需求一改再改,UI一调再调,结果就是项目中一堆已经用不到但却没有清理的垃圾资源,不说工程大小问题,对新进入项目的人或看其他模块的代码的人来说,这些没清理的资源可能也可能会带来困扰,所以最好还是清理掉这些垃圾,对于一个稍微大一点的工程来说,手工清理明显是不现实的,这就需要一个方法做这些事情. 清理资源文件 要清理没用的资源,首要的工作当然是找到他们,我们知道Anroid SDK中有一个工具叫lint,可以帮助我们查看工程中存在的问题,其中有一项功能就是查找			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYjqP5p.html" rel="bookmark">Android优化系列之apk瘦身</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 为什么APK要瘦身.APK越大,在下载安装过程中,他们耗费的流量会越多,安装等待时间也会越长:对于产品本身,意味着下载转化率会越低(因为竞品中,用户有更多机会选择那个体验最好,功能最多,性能最好,包最小的),所以apk的瘦身优化也很重要,本篇博客将讲述apk瘦身的相关内容. 包体分析 在Android Studio工具栏里,打开build–&gt;Analyze APK, 选择要分析的APK包 . 可以看到占用空间的主要是代码.图片.资源和lib和assert文件,主要方向精简代码.压缩图片.去			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOW7K3z.html" rel="bookmark">扇贝张志博--APK瘦身的实践与演进</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[51CTO.com原创稿件]扇贝是一个全面有效提升英语的移动互联网学习平台,有包括单词.听力.口语.新闻.阅读.炼句在内的六大应用,是目前国内唯一能让用户在移动端完成英语学习整个一套闭环的学习系统. 为什么要做APK瘦身? 一个很现实的事情是,到上个月底有23.49%用户使用移动网络使用App,其中有4.09%用户还在使用2G网络,这是一个很可怕的数字,因为到今天为止仍在使用Android2.3的用户已经是1%甚至连1%都不到的在网用户量,然而使用2G网络用户还有4.09%.因为现在用户使用移			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvr3d5M.html" rel="bookmark">APK瘦身记，如何实现高达53&percnt;的压缩效果</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				APK瘦身记,如何实现高达53%的压缩效果       1.我是怎么思考这件事情的 APK是Android系统安装包的文件格式,关于这个话题其实是一个老生常谈的题目,不论是公司内部,还是外部网络,前人前辈已经总结出很多方法和规律.不过随着移动端技术近两年的飞速发展,一些新的思维方式和优化方法也逐渐涌现和成熟起来.笔者在实践过程中踩过一些坑,收获了一些经验,在这里做个思考和总结,所以随笔给大家,希望对大家从事相关工作的时候有所帮助和参考,同时也是抛砖引玉,希望大家共同探讨这个开放性的话题. 关于为			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvmek8b.html" rel="bookmark">Android应用瘦身，从18MB到12&period;5MB</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开篇语 前阵子老大交给了我一个任务,主要是帮我们开发的直播应用做 Android 端的安装包瘦身,花了大概一周的时间把安装包从 18MB 减小到了 12.5MB.原本完全可以优化到 10MB 之下,但由于其他原因的限制,所以目前阶段只到 12.5MB 为止.在此记录一下优化的思路和用到的工具,方便自己以后 Review ,有需要的童鞋也可供参考. 瘦身的目的 从目的导向来看,我们是不会无缘无故去做一件事情的,那我们对应用瘦身的目的是为了什么?答案是:提高下载转化率.什么是下载转化率?举个栗子:你			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7o1jz.html" rel="bookmark">Android App瘦身实战</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着业务的快速迭代增长,不断引入新的业务逻辑代码.图片资源和第三方SDK等,很多app都面临一个一个结果,app越来越大,甚至很多无用的代码,包体积的增大带来了很多问题,诸如app启动更慢,代码维护越来越困难.公司业务发展到一定程度之后,重构,代码优化,app瘦身成为不得不做的一个任务.这里以xx外卖app为例给大家讲讲app瘦身过程中常用的几种方法(也都是网上老生常谈的). apk文件构成 我们可以用Zip工具打开APK,一个常见的APK结构如下: 可以看到APK由以下主要部分组成: 文件/目			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mqg1BZz.html" rel="bookmark">通过Gradle为APK瘦身</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文选自&lt;Gradle for Android 中文版&gt;,将研究如何设置Gradle 构建配置文件中的几个属性,以缩小APK 文件. ProGuard ProGuard 是一个Java 工具,其不仅可以缩减APK 文件大小,还可以在编译期优化.混淆和预校验你的代码.其通过你应用的所有代码路径,来找到未被使用的代码,并将其删除. ProGuard 还会重命名你的类和字段.这一过程将保留应用的踪迹,让反编译工程师更加难以读懂代码. 在Gradle 的Android 插件中,其构建类型下面有一个叫作			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bojZXXz.html" rel="bookmark">再谈Android应用瘦身</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android应用apk安装包的大小,虽然对于现在WiFi普及情况而言消耗流量已经微乎其微,但是,对于一款好的应用,对于一款负责任的应用,当然是越小越好了.   引言: .应用越小,下载越快,也就意味着新用户能在最短时间内安装,体验应用,而不是看着通知栏里面的丑陋的下载进度条,盯着看几分钟(30-50M的应用很常见,网不好,下载几分钟很正常)就像这样...   . 随着应用的迭代,应用必须满足人们越来越高的体验需求,应用需要更多的代码,更多的第三方库,更多的资源文件,随着设备的分辨率越来越高,资			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba4WEXz.html" rel="bookmark">Android APP瘦身（清除工程中没用到的资源）详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				清除Android工程中没用到的资源 项目需求一改再改,UI一调再调,结果就是项目中一堆已经用不到但却没有清理的垃圾资源,不说工程大小问题,对新进入项目的人或看其他模块的代码的人来说,这些没清理的资源可能也可能会带来困扰,所以最好还是清理掉这些垃圾,对于一个稍微大一点的工程来说,手工清理明显是不现实的,这就需要一个方法做这些事情. 清理资源文件 要清理没用的资源,首要的工作当然是找到他们,我们知道Anroid SDK中有一个工具叫lint,可以帮助我们查看工程中存在的问题,其中有一项功能就是查找			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2D53p.html" rel="bookmark" class="title">当SEO面对搜索引擎的&OpenCurlyDoubleQuote;&plus;1&rdquo;功能</a>
					<div>
						谷歌搜索引擎的&quot;+1&quot;功能相信很多站长都已经知道了并且有所了解.虽然目前还没有普及应用,但是意图可见一斑. 虽然是一个小小的&quot;+1&quot;这个按钮,他说明了什么问题呢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeOK9M.html" rel="bookmark" class="title">搜索引擎优化&lpar;SEO&rpar;和微博营销（SNS）的共同点</a>
					<div>
						自从微博诞生以来,越来越受到用户的欢迎,微博是从博客引伸而来的,但又有人说是抄袭美国的twiiter的,慢慢的微博也被很多人用来推广的方式了,做SEO的人应该很少去,了解微博营销,自从我的微博达到五千 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpd4A1p.html" rel="bookmark" class="title">通过Visual C&num;&period;NET建一个DTS任务</a>
					<div>
						visual 本文描述了如何利用Visual C#.net 创建一个DTS 自定义的任务.你可以通过C#.net创建自定义的任务的方式扩展DTS的功能.之后你可以安装并注册任务,他讲出现在DTS设计其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKPrAM.html" rel="bookmark" class="title">迅雷for Mac 2&period;6&period;1新功能：强力卸载功能</a>
					<div>
						迅雷 for Mac 2.6.1正式发布了!本次升级主要针Thunder Store卸载功能进行优化和改进,帮您彻底删除应用,清理出更多空间!还等什么,赶快下载试用吧~ Thunder: http:/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7LJLb.html" rel="bookmark" class="title">PHP字符串操作简单入门</a>
					<div>
						无论哪种语言,字符串操作都是一个重要的基础,往往是简单而重要.正像人说话一样,一般有形体 (图形界面),有语言(print 字符串?),显然字符串能解释更多的东西.PHP提供了大量的字符串操 作函数, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLa7Ob.html" rel="bookmark" class="title">使用名字空间</a>
					<div>
						16.2.1 名字空间的声明 名字空间的声明是关键字&quot;namespace&quot;后面跟名字空间名和名字空间主体,然后还可以跟一个分号.格式如下: namespace qualified- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDA0KBb.html" rel="bookmark" class="title">DNN中如何一次性插入多个模块</a>
					<div>
						需求有时候,我们要用几个模块才能实现某一组功能,比如Blog模块,我们需要一个模块用列表显示Blog条目,需要一个模块显示Blog内容,需要一个模块显示历史Blog发帖记录,需要一个模块显示搜索,所有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwVE3z.html" rel="bookmark" class="title">J2SE 1&period;5的注释语法</a>
					<div>
						说起注解语法,对于任何一个Java开发人员来说都已经耳熟能详了,我们每天都在使用着 @author, @param,等等编写注释,然后用javadoc生成文档.Java的这种方便的文档生成方法受到了开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyZ1db.html" rel="bookmark" class="title">WCF分布式开发步步为赢&lpar;13&rpar;&colon;WCF服务离线操作与消息队列MSMQ</a>
					<div>
						之前曾经写过一个关于MSMQ消息队列的文章:WCF分布式开发必备知识 (1):MSMQ消息队列 ,当时的目的也是用它来作为学习WCF 消息队列MSMQ编程的 基础文章.在那篇文章里,我们详细介绍了MS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlB23Vz.html" rel="bookmark" class="title">Photoshop美工教程：塑造美女紧身内衣曲线</a>
					<div>
						PS比较多的应用于网店商品处理,应用范围非常广泛,本例以紧身内衣服饰的处理为例,以PS塑造紧身内衣曲线进行讲述,现在网店的竞争相当激烈,如何使你的商品能吸引住顾客的眼球相当重要,紧身内衣重点是突出塑造 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjj54b.html" rel="bookmark" class="title">win7旗舰版系统Boot&period;ini文件是什么？</a>
					<div>
						win7旗舰版系统Boot.ini文件是什么?   步骤如下: 一.Boot.ini文件是什么 boot.ini文件简单来说就是系统启动引导的程序文件,在系统重装或者安装多系统的时候就会有它的发挥之处 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOa8lvM.html" rel="bookmark" class="title">EDA设计软件protel99se怎么用</a>
					<div>
						  EDA设计软件protel99se怎么用 Protel99SE是应用于Windows9X/2000/NT操作系统下的EDA设计软件,采用设计库管理模式,可以进行联网设计,具有很强的数据交换能力和开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3rj8z.html" rel="bookmark" class="title">As3&period;0 鼠标滚轮控制文本滚动代码</a>
					<div>
						 代码如下 复制代码 bar.addEventListener(MouseEvent.MOUSE_WHEEL, mouseWheel); if (e.delta &lt; 0) { //如果是向下滚动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEOl4p.html" rel="bookmark" class="title">flash 动态加载外部图片实现方法</a>
					<div>
						一.首先创建一个文本文件,用来存储图片信息,这个文件可以通过后台程序(如PHP)来修改生成. 新建文本文件名为imginfo.txt 以下是文本内容,是图片名称和描述的序列: 程序代码  代码如下 复 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6Rxjb.html" rel="bookmark" class="title">可视化继承中，工具栏怎么被锁定了？</a>
					<div>
						问题描述 Form1中有一个工具栏,Modifier属性为protected,工具栏上的按钮Modifier属性也为protected.新建一个Form2,继承自Form1.IDE中查看Form2发现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQoDWz.html" rel="bookmark" class="title">PL&sol;SQL --&amp;amp&semi;gt&semi; DML 触发器</a>
					<div>
						--======================= -- PL/SQL --&gt; DML 触发器 --=======================         何谓触发器?简言之,是一段命名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEZy4z.html" rel="bookmark" class="title">手机之外的入口在哪里</a>
					<div>
						除了自主品牌的手机终端,中国移动正在推动更多的自有硬件产品上市. 6月10日,据21世纪经济报道记者了解,在中国移动的音乐.视频.游戏.位置等基地业务中,已经有多个基地在谋划硬件产品. 其中,上海视频 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQV4Zp.html" rel="bookmark" class="title">一分钟了解阿里云产品：开放搜索五大热点技术问题分析</a>
					<div>
						在上一篇文章中,我们为大家介绍开放搜索的概况,开放搜索服务(OpenSearch)是一款结构化数据搜索托管服务,那在使用过程中,经常遇到的热门技术问题有哪些呢?   快速入门:   https://h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqR26Rp.html" rel="bookmark" class="title">sql server&period;&period;&period;-sql server如何实现16个以上联合主键</a>
					<div>
						问题描述 sql server如何实现16个以上联合主键 现在一个表的联合主键有16个,需要添加一个联合主键,但是sql server最多只能16个主键,怎么能实现17个键的需求? 解决方案 在SQL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB10Roz.html" rel="bookmark" class="title">信息可视化怎么运用</a>
					<div>
						图解的艺术--信息可视化运用 现如今人们身边存在着各类数据,能在这堆容易被忽视的繁杂数据油田里,可视化的方式挖掘出故事告诉大家.这就是信息可视化的特点所在. 信息可视化,起源于数据可视化,通俗的说也就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBVoqb.html" rel="bookmark" class="title">阿里云发布ECS磁盘加密，一键加密，业务0改动</a>
					<div>
						当下,数据安全问题层出不穷,数据安全已经成为企业用户的生命线.为了保障用户数据安全,阿里云ECS云服务器正式向全网客户发布了&quot;ECS磁盘加密&quot;功能. 阿里云 ECS 磁盘加密功能可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBB96z.html" rel="bookmark" class="title">有木有Struts2&plus;hibernate&plus;spring&plus;mysql的项目源码？求！！！</a>
					<div>
						问题描述 如题!!!要求项目能运行无误...数据库有创建数据库文件...如果谁有请联系我..QQ:506846716:先谢谢了!					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBjYjz.html" rel="bookmark" class="title">值得一试的4个大数据工具</a>
					<div>
						如今,大数据越来越重要,因为企业需要处理来自多个来源的不断增长的存储数据. 采用大数据可以称之为一场完美风暴.廉价的存储和大量的结构化和非结构化数据的大量涌入,导致了诸多的大型数据工具得以开发,帮助企 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwgg0M.html" rel="bookmark" class="title">Fork&sol;Join框架（五）在任务中抛出异常</a>
					<div>
						声明:本文是&lt; Java 7 Concurrency Cookbook&gt;的第五章,作者: Javier Fernández González 译者:许巧辉 校对:方腾飞 在任务中抛出异常  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJNy5p.html" rel="bookmark" class="title">awk 系列：如何使用 awk 内置变量</a>
					<div>
						我们将逐渐揭开 awk 功能的神秘面纱,在本节中,我们将介绍 awk 内置built-in变量的概念.你可以在 awk 中使用两种类型的变量,它们是:用户自定义user-defined变量(我们在第八 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdyVNmz.html" rel="bookmark" class="title">2&period; 假设编写一个ASP&period;NET，使用动态表格生成技术，将存储Application对象或Cache对象中数据项的名字及其值显示在表格中。</a>
					<div>
						问题描述 拜托大家! 解决方案 解决方案二:这是我在cs文件里写的protectedvoidPage_Load(objectsender,EventArgse){if(!IsPostBack){Cac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAoBrb.html" rel="bookmark" class="title">爱国者存储正式更名将推出平板电脑产品</a>
					<div>
						3月31日消息,华旗资讯集团旗下爱国者存储正式更名为爱国者电子科技有限公司,并计划于数月内推出平板电脑等新产品. 爱国者存储全国经销商大会日前在三亚举行,该公司总裁曲敬东公布了爱国者的新企业战略,并公 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1BBGb.html" rel="bookmark" class="title">jquery animate实现鼠标放上去显示离开隐藏效果&lowbar;jquery</a>
					<div>
						1.CSS样式: 复制代码 代码如下: @CHARSET &quot;UTF-8&quot;; * html .showbox,* html .overlay { position: absolute ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8NNyxb.html" rel="bookmark" class="title">安装PHP可能遇到的问题&OpenCurlyDoubleQuote;无法载入mysql扩展&rdquo; 的解决方法&lowbar;php技巧</a>
					<div>
						访问phpmyadmin时总是出现 &quot;无法载入 mysql 扩展,请检查 PHP 配置&quot;.查看原因是&quot;php_mysql.dll&quot;无法载如. 对于php 4.x ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOyo8b.html" rel="bookmark" class="title">ASP&period;NET实现自适应图片大小的弹窗 窗口可任意编辑</a>
					<div>
						在最近的项目中,遇到一个问题,要实现这样的效果: 点pic_small.Aspx页面的缩略图后弹出pic_all.aspx页面,pic_all.aspx页面的大小要根据图片大小自动调整,而且要有图片的 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.041 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
